<?php 
// CopyFolder.php 
// Recursively copy the directory structure and files from dir1 to dir2
// If a file already exists in dir2, do NOT copy it.

$from_dir = "C:/apache2/old_htdocs";
$dest_dir = "C:/apache2/htdocs";

function printline($msg) {
  echo $msg . PHP_EOL;
}
function recurse_copy($src,$dst) { 
  if (!is_dir("$src")) {
    printline("Source [$src] does not exist or is not a directory");
    return false;
  }
  printline("reading directory $src to copy its contents to $dst");
  $dir = opendir($src); 
  while (false !== ($file = readdir($dir))) {
    if ($file != '.' && $file != '..') {
      if ( is_dir("$src/$file") ) { 
        // if the subdirectory does not exist in dest, create it
        printline("found subdirectory $file in $src");
        if (is_dir("$dst/$file")) {
          printline("directory $file already exists in $dst");
        }
        else {
          printline("creating directory $dst/$file");
          mkdir("$dst/$file");
        }
        recurse_copy("$src/$file", "$dst/$file"); 
      } 
      else { 
        // it is a file, if it does not exist in dest, copy it
        printline("found file $file in $src");
        if (is_file("$dst/$file")) {
          printline("file $file already exists in $dst");
        }
        else {
          printline("copying file $file from $src to $dst");
          copy("$src/$file", "$dst/$file"); 
        }
      } 
    } 
  } 
  closedir($dir); 
  return true;
} 

// main logic - call the recursive copy on top directories
if (recurse_copy($from_dir,$dest_dir))
  printline("Copy completed successfully");

?>
